var ae = Object.defineProperty;
var re = (r, t, a) => t in r ? ae(r, t, { enumerable: !0, configurable: !0, writable: !0, value: a }) : r[t] = a;
var E = (r, t, a) => (re(r, typeof t != "symbol" ? t + "" : t, a), a);
import { EditFormModel as oe, FormMDCtrlModel as ne, AppEntityModel as W } from "@ibiz-template/model";
import { useNamespace as R, useControlController as ie, usePropsWatch as le, getDatePickerProps as ce, getEditorEmits as de, useController as ue } from "@ibiz-template/vue-util";
import { defineComponent as B, getCurrentInstance as J, ref as C, watch as L, h as e, onMounted as me } from "vue";
import { createUUID as q } from "qx-util";
import { ViewMode as X, PluginStaticResource as pe, UIActionHandler as he, FrontUIActionHandler as fe, OpenAppViewCommand as ve } from "@ibiz-template/runtime";
import { EditFormController as ge, FormMDCtrlController as ye, DatePickerEditorController as De, UploadEditorController as Ee } from "@ibiz-template/controller";
import { ControlVO as Ce, calcResPath as Z } from "@ibiz-template/service";
import Y from "dayjs";
import { StringUtil as be } from "@ibiz-template/core";
class Fe extends ge {
  constructor() {
    super(...arguments);
    /**
     *   基础数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 17:04:49
     * @type {IData}
     */
    E(this, "baseResData", []);
    /**
     *   对比数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 17:04:49
     * @type {IData}
     */
    E(this, "compareResData", []);
    /**
     * 表单旧数据
     *
     * @author zk
     * @date 2023-12-20 11:12:43
     * @protected
     * @type {IData}
     * @memberof FormController
     */
    E(this, "oldData", new Ce());
    /**
     * version数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 16:04:37
     * @type {IData[]}
     */
    E(this, "versionData", []);
    /**
     *  对比数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 16:04:37
     * @type {IData[]}
     */
    E(this, "comparisonArr", {});
    /**
     *  基础表格数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:57
     * @type {IData[]}
     */
    E(this, "gridData", []);
    /**
     *  展示完全数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:04
     * @type {IData[]}
     */
    E(this, "AllGridData", []);
    /**
     *  去除相同数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:15
     * @type {IData[]}
     */
    E(this, "removeSameGridData", []);
    /**
     *  关系界面数据
     *
     * @author fangZhiHao
     * @date 2024-04-30 10:04:33
     * @type {IData}
     */
    E(this, "AlldruipartData", /* @__PURE__ */ new Map());
    /**
     *  关系界面数据长度
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:56
     * @type {number}
     */
    E(this, "druipartDataSize", 0);
    /**
     *   关系界面实际数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:13
     * @type {IData}
     */
    E(this, "newDruipartData", {});
  }
  /**
   * 加载数据
   *
   * @return {*}  {Promise<ControlVO>}
   * @memberof FormDataComparisonController
   */
  async loadGridData() {
    await this.startLoading();
    const a = this.model.source.M.getPSControlParam.ctrlParams, { BASEENTITY: o, COMPAREENTITY: d } = a, v = await ibiz.entityService.getService(o), g = await ibiz.entityService.getService(d), y = Object.assign({}, this.context.clone(), {
      [o.toLowerCase()]: this.params.base_version
    }), u = Object.assign({}, this.context.clone(), {
      [d.toLowerCase()]: this.params.compare_version
    }), m = await v.exec("Get", y, this.params), p = await g.exec(
      "Get",
      u,
      this.params
    );
    return this.isLoaded = !0, {
      baseData: m.data.data,
      compareData: p.data.data
    };
  }
  /**
   * 判断值是否为空
   *
   * @param {(string | IData[] | null | undefined)} value
   * @return {*}
   * @memberof FormDataComparisonController
   */
  isFalseyButNotEmpty(a) {
    return a == null || typeof a == "string" && a === "" || Array.isArray(a) && a.length === 0 || typeof a == "object" && Object.keys(a).length === 0;
  }
  /**
   * 比较两个值
   *
   * @param {IData} objA
   * @param {IData} objB
   * @return {*}
   * @memberof FormDataComparisonController
   */
  compareObjectValues(a, o) {
    return JSON.stringify(a) !== JSON.stringify(o);
  }
}
const Pe = B({
  name: "IBizFormDataComparison",
  props: {
    modelData: {
      type: oe,
      required: !0
    },
    context: {
      type: Object,
      required: !0
    },
    params: {
      type: Object,
      default: () => ({})
    },
    enableAutoSave: {
      type: Boolean,
      required: !1
    }
  },
  setup(r) {
    const t = R("form-data-comparison"), {
      proxy: a
    } = J(), o = ie(a, () => {
      const s = new Fe(r.modelData, r.context, r.params);
      return le(a, "enableAutoSave", s.setEnableAutoSave.bind(s)), s;
    }), d = C(!0), v = C(!1), g = C({}), y = C({}), u = C([]), m = [], p = C([]), i = C([]), c = C([]), l = /* @__PURE__ */ new Map(), h = C(0), f = (s) => {
      const n = [];
      if (n.push(s), s && s.children) {
        const D = [];
        s.children.forEach((F) => {
          const I = f(F);
          D.push(...I);
        }), n.push(...D);
      }
      return n;
    }, b = f(r.modelData);
    m.push(...b);
    const P = (s) => {
      const n = o.details[s.source.name], D = e("not-supported-editor", {
        attrs: {
          modelData: s.editor
        }
      });
      return e("div", {
        class: [t.e("form-grid-item"), t.is("add", p.value.includes(s.source.name)), t.is("update", c.value.includes(s.source.name)), t.is("delete", i.value.includes(s.source.name))]
      }, [e("div", {
        class: t.em("form-grid-item", "name")
      }, [s.source.caption]), e("div", {
        class: t.em("form-grid-item", "left")
      }, [n.editorProvider ? e(n.editorProvider.formEditor, {
        props: {
          value: y.value[s.source.name],
          data: n.data,
          controller: n.editor,
          disabled: n.disabled,
          readonly: !0
        }
      }) : D]), e("div", {
        class: t.em("form-grid-item", "right")
      }, [n.editorProvider ? e(n.editorProvider.formEditor, {
        props: {
          value: g.value[s.source.name],
          data: n.data,
          controller: n.editor,
          disabled: n.disabled,
          readonly: !0
        }
      }) : D])]);
    }, A = (s, n) => {
      l.set(s.source.id, n), n.evt.on("mounted", () => {
        d.value && o.startLoading(), h.value += 1, n.call.refresh();
      }), n.evt.on("refreshed", () => {
        h.value -= 1, setTimeout(() => {
          d.value && o.endLoading();
        }, 500);
      });
    }, _ = (s) => {
      const n = m.find((O) => O.id === `${s.source.id}_srfcopy`), D = s.embedView.source.modelPath, F = n == null ? void 0 : n.embedView.source.modelPath, I = o.context.clone(), w = {
        base_version: r.params.base_version
      }, N = o.context.clone();
      Object.assign(N, {
        gysrlzy_info: r.params.compare_version,
        compare_version: r.params.compare_version
      });
      const S = {
        compare_version: r.params.compare_version
      }, T = g.value[s.source.userTag], M = y.value[n == null ? void 0 : n.source.userTag];
      let z = !1, U = !1, j = !1;
      if (s.source.userTag2) {
        const O = JSON.parse(s.source.userTag2), {
          comparekey: G,
          comparelist: se
        } = O;
        T && M && Array.isArray(T) && Array.isArray(M) && (T.length === 0 && M.length !== 0 ? j = !0 : T.length !== 0 && M.length === 0 ? z = !0 : T.length !== 0 && M.length !== 0 && (T.length !== M.length ? U = !0 : T.some((H) => {
          const K = M.find((x) => H[G] === x[G]);
          return K ? se.some((x) => H[x] !== K[x] ? (U = !0, !0) : !1) : (U = !0, !0);
        })));
      }
      return e("div", {
        class: [t.e("druipart"), t.is("add", z), t.is("update", U), t.is("delete", j)]
      }, [e("div", {
        class: t.em("druipart", "caption")
      }, [s.source.caption]), e("div", {
        class: t.em("druipart", "left")
      }, [F && e("ViewShell", {
        attrs: {
          context: N,
          params: S,
          modal: {
            mode: X.EMBED
          },
          modelPath: F,
          noLoadDefault: !0,
          name: n == null ? void 0 : n.source.id
        },
        key: q(),
        on: {
          neuronInit: (O) => A(n, O)
        }
      })]), e("div", {
        class: t.em("druipart", "right")
      }, [D && e("ViewShell", {
        attrs: {
          context: I,
          params: w,
          modal: {
            mode: X.EMBED
          },
          modelPath: D,
          noLoadDefault: !0,
          name: s.source.id
        },
        key: q(),
        on: {
          neuronInit: (O) => A(s, O)
        }
      })])]);
    }, $ = (s) => {
      const n = {
        modelData: s,
        controller: o.details[s.source.name]
      }, D = o.providers[s.source.name], F = e(D.component, {
        props: {
          ...n
        },
        key: s.id
      }), I = e(D.component, {
        props: {
          ...n
        },
        key: `compare_${s.id}`
      });
      return e("div", {
        class: t.e("mdctrl")
      }, [e("div", {
        class: t.em("mdctrl", "caption")
      }, [s.source.caption]), e("div", {
        class: t.em("mdctrl", "left")
      }, [F]), e("div", {
        class: t.em("mdctrl", "right")
      }, [I])]);
    }, k = (s) => {
      d.value = !1;
      const n = u.value.findIndex((D) => D === s.source.name);
      n > -1 ? u.value.splice(n, 1) : u.value.push(s.source.name);
    }, V = (s) => {
      if (!s.source.hidden) {
        if (s.source.detailType === "FORMPAGE")
          return e("div", {
            class: t.e("form-page")
          }, [s.children.map((n) => V(n))]);
        if (s.source.detailType === "FORMITEM") {
          const n = p.value.includes(s.source.name), D = i.value.includes(s.source.name), F = c.value.includes(s.source.name);
          return v.value && !n && !D && !F ? null : P(s);
        }
        if (s.source.detailType === "GROUPPANEL") {
          const n = u.value.includes(s.source.name);
          return e("div", {
            class: t.b("group")
          }, [e("div", {
            class: [t.be("group", "header"), t.is("hide-caption", !s.source.showCaption)]
          }, [e("div", {
            class: t.bem("group", "header", "name")
          }, [n ? e("i-icon", {
            class: t.bem("group", "header", "icon"),
            attrs: {
              type: "ios-arrow-forward",
              title: "展开"
            },
            on: {
              click: () => k(s)
            }
          }) : e("i-icon", {
            class: t.bem("group", "header", "icon"),
            attrs: {
              type: "ios-arrow-down",
              title: "收缩"
            },
            on: {
              click: () => k(s)
            }
          }), e("span", {
            class: t.bem("group", "header", "name-text")
          }, [s.source.caption || s.source.title])]), e("div", ["---"]), e("div", ["---"])]), e("div", {
            class: [t.be("group", "content"), t.is("collapse", n)]
          }, [s.children.map((D) => V(D))])]);
        }
        return s.source.detailType === "DRUIPART" && !s.source.name.endsWith("_srfcopy") ? _(s) : s.source.detailType === "MDCTRL" ? $(s) : null;
      }
    }, te = (s, n) => {
      const D = [], F = [], I = [];
      return Object.keys(n).forEach((w) => {
        const N = s[w], S = n[w];
        o.isFalseyButNotEmpty(N) && !o.isFalseyButNotEmpty(S) && D.push(w), !o.isFalseyButNotEmpty(N) && !o.isFalseyButNotEmpty(S) && o.compareObjectValues(N, S) && F.push(w);
      }), Object.keys(s).forEach((w) => {
        if (!Object.prototype.hasOwnProperty.call(n, w) || o.isFalseyButNotEmpty(n[w])) {
          const N = s[w];
          o.isFalseyButNotEmpty(N) || I.push(w);
        }
      }), {
        added: D,
        modified: F,
        deleted: I
      };
    };
    return L(() => r.params, async () => {
      const s = await o.loadGridData();
      g.value = s.baseData, y.value = s.compareData;
      const {
        added: n,
        modified: D,
        deleted: F
      } = te(y.value, g.value);
      p.value = n, c.value = D, i.value = F;
    }, {
      immediate: !0
    }), {
      ns: t,
      c: o,
      switchValue: v,
      druipartNum: h,
      renderEditor: P,
      renderByDetailType: V
    };
  },
  render() {
    return this.c.complete ? e("control-layout", {
      attrs: {
        modelData: this.c.model
      }
    }, [e("div", {
      class: this.ns.b()
    }, [e("div", {
      class: this.ns.e("top")
    }, [e("div", {
      class: this.ns.e("top-hidesame-content")
    }, [e("div", {
      class: this.ns.e("top-hidesame-content-left")
    }, ["隐藏相同项 ", e("i-switch", {
      model: {
        value: this.switchValue,
        callback: (r) => {
          this.switchValue = r;
        }
      }
    })]), e("div", {
      class: this.ns.e("top-hidesame-content-right")
    }, [e("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["新增", e("div", {
      class: this.ns.e("top-hidesame-content-right-item-add")
    })]), e("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["修改", e("div", {
      class: this.ns.e("top-hidesame-content-right-item-change")
    })]), e("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["删除", e("div", {
      class: this.ns.e("top-hidesame-content-right-item-delete")
    })])])]), e("div", {
      class: this.ns.e("top-content")
    }, [e("div", {
      class: this.ns.em("top-content", "attr")
    }, ["信息项"]), e("div", {
      class: [this.ns.em("top-content", "left")]
    }, ["更新前内容"]), e("div", {
      class: [this.ns.em("top-content", "right")]
    }, ["更新后内容"])])]), e("div", {
      class: this.ns.e("content")
    }, [this.modelData.children.map((r) => this.renderByDetailType(r))])])]) : null;
  }
});
const we = B({
  name: "CustomDataImport",
  props: {
    templateUrl: {
      type: String,
      required: !0
    },
    importUrl: {
      type: String,
      required: !0
    },
    dismiss: {
      type: Function
    }
  },
  setup(r, {
    emit: t
  }) {
    const a = R("data-import"), o = C(), d = C({
      state: "ready",
      message: "",
      rowError: []
    }), v = C(""), g = async (i) => {
      const c = new FormData(), l = Y(v.value).format("YYYY-MM");
      c.append("file", i), c.append("ny", l);
      try {
        const h = await ibiz.net.request(r.importUrl, {
          method: "post",
          data: c,
          headers: {
            "Content-Type": "multipart/form-data"
          }
        });
        d.value.state = "success", d.value.message = "导入成功";
        const {
          errorinfo: f,
          success: b,
          total: P
        } = h.data, A = P ? Number(P) : 0, _ = b ? Number(b) : 0, $ = P - b;
        d.value.message = `共计导入数据 ${A} 条，错误[${$}]，成功[${_}]`, f && Object.keys(f).length > 0 && (d.value.rowError = [], Object.keys(f).forEach((k) => {
          d.value.rowError.push({
            index: Number(k) + 1,
            info: f[k].errorInfo
          });
        }));
      } catch (h) {
        d.value.state = "fail", d.value.message = `导入失败！${h.message}`;
      }
    }, y = (i) => {
      const c = i.target;
      if (!c.files)
        return;
      const l = c.files[0];
      c.value = null, g(l);
    }, u = async () => {
      var c;
      const i = await ibiz.net.request(r.templateUrl, {
        responseType: "blob"
      });
      if (i.status === 200) {
        let l = ((c = i.headers["content-disposition"].split(";").find((b) => b.indexOf("filename=") !== -1)) == null ? void 0 : c.slice(9)) || "";
        l = decodeURIComponent(l);
        const h = new Blob([i.data], {
          type: "application/vnd.ms-excel"
        }), f = document.createElement("a");
        f.download = l, f.style.display = "none", f.href = URL.createObjectURL(h), document.body.appendChild(f), f.click(), URL.revokeObjectURL(f.href), document.body.removeChild(f);
      }
    }, m = () => {
      o.value.click();
    }, p = () => {
      var i;
      t("close", {
        ok: !1,
        data: {}
      }), (i = r.dismiss) == null || i.call(r, {
        ok: !1,
        data: {}
      });
    };
    return me(() => {
      v.value = Y().format("YYYY年MM月");
    }), {
      ns: a,
      curDate: v,
      onLinkClick: u,
      selectFile: m,
      onCancelButtonClick: p,
      onFileChange: y,
      inputUpLoad: o,
      message: d
    };
  },
  render() {
    return e("div", {
      class: [this.ns.b(), this.ns.is("custom", !0)]
    }, [e("input", {
      ref: "inputUpLoad",
      attrs: {
        type: "file",
        accept: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
      },
      style: "display: none",
      on: {
        change: this.onFileChange
      }
    }), e("div", {
      class: this.ns.e("caption")
    }, ["导入数据"]), e("div", {
      class: this.ns.e("date")
    }, [e("span", ["导入数据所属月份"]), e("i-datePicker", {
      attrs: {
        format: "yyyy年MM月",
        type: "month",
        clearable: !1
      },
      model: {
        value: this.curDate,
        callback: (r) => {
          this.curDate = r;
        }
      }
    })]), this.message.state === "ready" ? e("div", {
      class: this.ns.b("upload"),
      on: {
        click: this.selectFile
      }
    }, [e("img", {
      class: this.ns.be("upload", "img"),
      attrs: {
        src: "./assets/img/icon-import.svg"
      }
    }), e("span", {
      class: this.ns.be("upload", "text")
    }, ["单击此区域进行上传"])]) : e("div", {
      class: this.ns.b("message")
    }, [e("div", {
      class: this.ns.be("message", "title")
    }, ["导入结果"]), e("div", {
      class: this.ns.be("message", "content")
    }, [this.message.message]), this.message.rowError.length > 0 && [e("div", {
      class: this.ns.be("message", "title")
    }, ["错误信息"]), e("div", {
      class: this.ns.be("message", "content")
    }, [this.message.rowError.map((r) => e("div", [`第 ${r.index} 行：${r.info}`]))])]]), e("div", {
      class: this.ns.e("template-container")
    }, [e("div", {
      class: this.ns.e("template-description")
    }, ["下载导入模版，并按要求填写："]), e("div", {
      class: this.ns.e("template-link"),
      on: {
        click: this.onLinkClick
      }
    }, [e("i-icon", {
      attrs: {
        type: "ios-link"
      }
    }), "数据导入模板文件"])]), e("div", {
      class: this.ns.e("button-bar")
    }, [this.message.state !== "ready" && e("i-button", {
      on: {
        click: this.selectFile
      }
    }, ["重新上传"])])]);
  }
});
const Ae = B({
  name: "YearMonthPicker",
  props: ce(),
  emits: de(),
  setup(r, {
    emit: t
  }) {
    const a = R("date-picker"), o = r.controller, d = o.model, v = C("date"), g = C("yyyy-MM-dd"), y = C(!1);
    switch (d.editorType) {
      case "DATEPICKEREX":
      case "DATEPICKEREX_NOTIME":
        v.value = "date";
        break;
      case "DATEPICKEREX_NODAY":
      case "DATEPICKEREX_NODAY_NOSECOND":
        y.value = !0, v.value = "time";
        break;
      case "DATEPICKEREX_HOUR":
      case "DATEPICKEREX_MINUTE":
      case "DATEPICKEREX_SECOND":
      case "DATEPICKEREX_NOSECOND":
      case "DATEPICKER":
      default:
        v.value = "datetime";
    }
    const u = o.valueFormat;
    if (u) {
      u === "YYYY-MM" ? v.value = "month" : u === "YYYY" && (v.value = "year");
      const l = u.replace("YYYY", "yyyy").replace("DD", "dd");
      g.value = l;
    }
    d.editorParams.formatText && (g.value = d.editorParams.formatText.replace("YYYY", "yyyy").replace("DD", "dd"));
    const m = C();
    L(() => r.value, (l, h) => {
      l && l !== h && (m.value = Y(l).format(u));
    }, {
      immediate: !0
    });
    const p = (l, h) => {
      if (l) {
        const f = Y(l.replace(/[年月]/g, "-")).format(u);
        t("change", f);
      } else
        t("change", l);
    }, i = (l) => {
      t("operate", l);
    }, c = C();
    return r.autoFocus && L(c, (l) => {
      l && l.$el.getElementsByTagName("input")[0].click();
    }), {
      ns: a,
      c: o,
      editorModel: d,
      type: v,
      format: g,
      formatValue: m,
      handleChange: p,
      onOpenChange: i,
      inputRef: c,
      isTimePicker: y
    };
  },
  render(r) {
    return r("div", {
      class: [this.ns.b(), this.disabled ? this.ns.m("disabled") : "", this.readonly ? this.ns.m("readonly") : ""]
    }, [[this.readonly && this.formatValue, !this.readonly && this.isTimePicker && r("ITimePicker", {
      ref: "inputRef",
      props: {
        ...this.c.customProps,
        value: this.value,
        type: this.type,
        format: this.format,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        transfer: !0
      },
      on: {
        "on-change": this.handleChange,
        "on-open-change": this.onOpenChange
      }
    }), !this.readonly && !this.isTimePicker && r("ICalendarPicker", {
      ref: "inputRef",
      props: {
        ...this.c.customProps,
        value: this.value,
        type: this.type,
        format: this.format,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        transfer: !0
      },
      on: {
        "on-change": this.handleChange,
        "on-open-change": this.onOpenChange
      }
    })]]);
  }
});
const Q = new pe(import.meta.url), Ie = B({
  name: "DownLoadSafeFile",
  props: {},
  setup() {
    const r = R("download-safe-file"), t = Q.dir("/assets/doc/safe-file.doc");
    return {
      ns: r,
      url: t
    };
  },
  render() {
    return e("div", {
      class: this.ns.b()
    }, [e("a", {
      attrs: {
        download: "网络信息安全承诺书.doc",
        href: this.url
      }
    }, ["网络信息安全承诺书.doc"])]);
  }
});
class ee extends ye {
  connect(t, a) {
    this.formNeurons.get(t) || (this.formNeurons.set(t, a), a.evt.on("mounted", () => {
      a.call.load();
    }), a.evt.on("destroyed", () => {
      this.formNeurons.delete(t);
    }), a.evt.on("valueChange", (o) => {
      if (o) {
        const d = this.contentCtrlData.find((v) => v.srfkey === o.srfkey);
        d && Object.assign(d, o), this.force();
      }
    }));
  }
}
const Ne = B({
  name: "FormMDCtrlFormStyle2",
  props: {
    controller: {
      type: ee,
      required: !0
    },
    modelData: {
      type: ne,
      required: !0
    }
  },
  setup(r) {
    const t = R("form-mdctrl-form-style2"), a = r.controller, o = C(0), {
      proxy: d
    } = J();
    ue(d, r.controller);
    const v = async (m, p, i) => {
      i.stopPropagation(), i.preventDefault();
      const c = a.contentCtrlData.length;
      await a.handleRemove(m, p), c !== a.contentCtrlData.length && p <= o.value && o.value !== 0 && (o.value -= 1);
    }, g = (m) => {
      o.value = m, a.force();
    }, y = () => {
      const m = r.modelData.source.userTag;
      let p = {};
      m && (p = JSON.parse(m));
      const {
        tabtitle: i,
        addtitle: c
      } = p;
      return e("div", {
        class: t.e("header")
      }, [a.contentCtrlData.map((l, h) => {
        let f = `新建${h + 1}`;
        return l.srfmajortext ? f = l.srfmajortext : i && l[i] ? f = l[i] : c && (f = `${c}${h + 1}`), e("div", {
          class: [t.e("header-item"), t.is("actived", h === o.value)],
          on: {
            click: () => g(h)
          }
        }, [e("div", {
          class: t.em("header-item", "title")
        }, [f]), e("div", {
          class: t.em("header-item", "delete"),
          attrs: {
            title: "移除"
          },
          on: {
            click: (b) => v(l, h, b)
          }
        }, [e("i", {
          class: "fa fa-close"
        })])]);
      }), e("div", {
        class: [t.e("header-item"), t.e("add")],
        attrs: {
          title: "添加"
        },
        on: {
          click: () => a.handleAdd()
        }
      }, [e("span", ["添加"]), e("i", {
        class: "fa fa-plus"
      })])]);
    };
    return L(() => a.form.isLoaded, (m, p) => {
      m !== p && m === !0 && a.loadData();
    }), {
      ns: t,
      rendertanHeader: y,
      renderTabs: () => a.contentCtrlData.map((m, p) => {
        var l;
        let i = null;
        const {
          form: c
        } = a.model;
        if (c && a.providers[c.name] && a.model.appEntity) {
          const h = Object.assign(a.form.context.clone(), {
            [(l = a.model.appEntity.codeName) == null ? void 0 : l.toLowerCase()]: m[a.model.appEntity.keyName]
          });
          i = e(a.providers[c.name].component, {
            props: {
              modelData: c,
              context: h,
              params: a.form.params,
              enableAutoSave: !0,
              silentVerify: !0
            },
            on: {
              neuronInit: a.onNeuronInit(m.srfkey)
            }
          });
        }
        return e("div", {
          class: [t.e("content"), t.is("actived", p === o.value)],
          key: m.srfkey
        }, [i]);
      })
    };
  },
  render() {
    return e("div", {
      class: this.ns.b()
    }, [this.rendertanHeader(), this.renderTabs()]);
  }
});
class Te {
  constructor() {
    E(this, "component", "IBizFormDataComparison");
  }
}
class Me extends he {
  async execAction(t, a, o, d) {
    const v = {}, g = t.getPSAppDataEntity();
    if (g) {
      g.isFill === !1 && await g.fill(!0);
      const y = new W(g);
      await y.init();
      const { resultContext: u } = await this.handleParams(
        t,
        a,
        o,
        d
      ), m = ibiz.resourcePathUtil.calcPaths(
        u,
        y.codeName
      ), p = Z(u, m);
      let i = `${p}/${y.deNamePlural}/importtemplate`, c = `${p}/${y.deNamePlural}/importdata2`;
      const l = t.getPSAppDEDataImport();
      l && (i += `?srfimporttag=${l.codeName}`, c += `?srfimporttag=${l.codeName}`);
      const h = ibiz.overlay.createModal(
        "CustomDataImport",
        {
          templateUrl: i,
          importUrl: c,
          dismiss: (f) => {
            h.dismiss(f);
          }
        },
        {
          width: "auto",
          placement: "center"
        }
      );
      return h.present(), await h.onWillDismiss(), {
        refresh: !0
      };
    }
    return v;
  }
}
class Oe {
  constructor() {
    E(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new Me()), this.handler;
  }
}
class ke {
  constructor() {
    E(this, "gridEditor", "YearMonthPicker");
    E(this, "formEditor", "YearMonthPicker");
  }
  async createController(t, a) {
    const o = new De(t, a);
    return await o.init(), o;
  }
}
class Se {
  constructor() {
    E(this, "formEditor", "DownLoadSafeFile");
    E(this, "gridEditor", "DownLoadSafeFile");
  }
  async createController(t, a) {
    const o = new Ee(t, a);
    return await o.init(), o;
  }
}
class Re extends fe {
  async execAction(t, a, o, d, v) {
    const g = {}, { frontProcessType: y } = t;
    if (y === "OPENHTMLPAGE") {
      const u = be.fill(t.htmlPageUrl, a, o == null ? void 0 : o[0]);
      window.open(u, "_blank");
    }
    if (y === "DATAIMP") {
      const u = t.getPSAppDataEntity();
      if (u) {
        u.isFill === !1 && await u.fill(!0);
        const m = new W(u);
        await m.init();
        const { resultContext: p } = await this.handleParams(
          t,
          a,
          o,
          d
        ), i = ibiz.resourcePathUtil.calcPaths(
          p,
          m.codeName
        ), c = Z(p, i);
        let l = `${c}/${m.deNamePlural}/importtemplate`, h = `${c}/${m.deNamePlural}/importdata2`;
        const f = t.getPSAppDEDataImport();
        f && (l += `?srfimporttag=${f.codeName}`, h += `?srfimporttag=${f.codeName}`);
        const b = ibiz.overlay.createModal(
          "DataImport",
          {
            templateUrl: l,
            importUrl: h,
            dismiss: (P) => {
              b.dismiss(P);
            }
          },
          {
            width: "auto",
            placement: "center"
          }
        );
        return b.present(), await b.onWillDismiss(), {
          refresh: !0
        };
      }
    }
    if (["TOP", "WIZARD"].includes(y)) {
      const u = t.getFrontPSAppView();
      if (!u)
        throw new Error("未配置打开视图");
      await u.fill(!0);
      const { resultContext: m, resultParams: p } = await this.handleParams(
        t,
        a,
        o,
        d
      ), i = await ibiz.commands.execute(
        ve.TAG,
        u,
        m,
        p,
        v
      );
      (i == null ? void 0 : i.ok) === !1 && (g.closeView = !1, g.refresh = !1, g.cancel = !0), i != null && i.ok && i.data && (g.data = i.data);
    } else if (v) {
      const { neuron: u } = v, p = u.call.getFormController().call.getFormController(), { druipart1: i, druipart2: c, druipart3: l } = p.details;
      [
        {
          message: "服务履历为空",
          neuron: i
        },
        {
          message: "教育经验为空",
          neuron: c
        },
        {
          message: "项目经验为空",
          neuron: l
        }
      ].some((b) => {
        const P = b.neuron.neuron.call.getGridController();
        if (P) {
          const A = P.call.getGridController();
          if (A && A.items && A.items.length > 0)
            return !1;
        }
        return ibiz.message.error(`${b.message}`, 1.5, !0), !0;
      }) || await u.call.wfStart();
    }
    return g;
  }
}
class Be {
  constructor() {
    E(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new Re()), this.handler;
  }
}
class Ue {
  constructor() {
    E(this, "component", "FormMDCtrlFormStyle2");
  }
  async createController(t, a, o) {
    const d = new ee(t, a, o);
    return await d.init(), d;
  }
}
const Ke = {
  mateUrl: import.meta.url,
  install(r) {
    Q.loadStyle(["/style.css"]), r.component("IBizFormDataComparison", Pe), r.component("CustomDataImport", we), r.component("YearMonthPicker", Ae), r.component("DownLoadSafeFile", Ie), r.component("FormMDCtrlFormStyle2", Ne), ibiz.register.control.register(
      "EDITFORM_RENDER_FORM_DATA_COMPARISON",
      new Te()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_CUSTOM_IMPORT",
      new Oe()
    ), ibiz.register.editor.register(
      "DATEPICKEREX_NOTIME_YEAR_MONTH_PICKER",
      new ke()
    ), ibiz.register.editor.register(
      "FILEUPLOADER_ONE_DOWNLOAD_FILE",
      new Se()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_JUDEG_ENABLE_UPDATE",
      new Be()
    ), ibiz.register.formDetail.register(
      "FORM_USERCONTROL_MUL_FORM_CARD",
      new Ue()
    );
  }
};
export {
  Ke as default
};
